echo OFF
rem
rem How To Execute:
rem Open a Command window by hitting the Windows key and then type the three letters C, M and D and then hit the enter/return key.
rem Drag and drop this script into the Command window and hit the enter/return key.
rem Congratulations, after a few seconds the file scanVSTsOutput.txt shall be on your Desktop
rem
setlocal enableExtensions
setlocal enableDelayedExpansion


set DoricoVers="unknown"
set VAEVers="unknown"

set OUTPUTFILE=%UserProfile%\Desktop\scanVSTsOutput.txt
del %OUTPUTFILE% >NUL 2>NUL

rem Find the latest Dorico inst
if exist "%ProgramFiles%\Steinberg\Dorico3.5\Dorico3.5.exe" (
	set "DoricoVers=3.5"
	set "VAEVers=3"
)
if exist "%ProgramFiles%\Steinberg\Dorico4\Dorico4.exe" (
	set "DoricoVers=4"
	set "VAEVers=5"
)
if exist "%ProgramFiles%\Steinberg\Dorico5\Dorico5.exe" (
	set "DoricoVers=5"
	set "VAEVers=5.5"
)

echo Found Dorico vers %DoricoVers% and VAE vers %VAEVers% >> %OUTPUTFILE%

if %DoricoVers%=="unknown" exit -1
if %VAEVers%=="unknown" exit -1


set inputfile="%APPDATA%\Steinberg\Dorico %DoricoVers% AudioEngine_64\Vst2xPlugin SearchPaths Dorico %DoricoVers% AudioEngine.xml"
set "vst2scannerexe=%ProgramFiles%\Steinberg\Dorico%DoricoVers%\VSTAudioEngine\Components\vst2xscanner.exe"
set "vst3scannerexe=%ProgramFiles%\Steinberg\Dorico%DoricoVers%\VSTAudioEngine\Components\vstscanner.exe"
set vst3path="C:\Program Files\Common Files\VST3"

echo Using as input: %inputfile% >> %OUTPUTFILE%
echo Using as VST2scanner: %vst2scannerexe% >> %OUTPUTFILE%
echo Using as VST3scanner: %vst3scannerexe% >> %OUTPUTFILE%
echo %DATE% %TIME% >> %OUTPUTFILE% 
echo Scanning VST plug-ins...
echo(
echo VST2 plug-ins: >> %OUTPUTFILE%


for /f usebackq^ delims^=^"^ tokens^=1-5 %%i in (%inputfile%) do (
	if /i "%%j"=="Name" (
		set pathname=%%l
		)
	if /i "%%j"=="Path" (
		set pathpath=%%l
		set filepath=!pathpath!!pathname!\*.dll
		for /f "delims=" %%n in ('DIR /s/b "!filepath!"') do (
			echo( >> %OUTPUTFILE%
			echo %%n >> %OUTPUTFILE%
			"%vst2scannerexe%" -p "%%n" >> %OUTPUTFILE%
			set /A errNr=!ERRORLEVEL!
			if !errNr! equ 1 echo Failed with error Unknown >> %OUTPUTFILE%
			if !errNr! equ 2 echo Failed with error Not64Bit >> %OUTPUTFILE%
			if !errNr! equ 3 echo Failed with error InvalidCodeSignature >> %OUTPUTFILE%
			if !errNr! equ 4 echo Failed with error PrePluginCheckFailed >> %OUTPUTFILE%
			if !errNr! equ 5 echo Failed with error PostPluginCheckFailed >> %OUTPUTFILE%
			if !errNr! equ 6 echo Failed with error ScanPluginFailed >> %OUTPUTFILE%
		)
	)
)

echo( >> %OUTPUTFILE%
echo VST3 plug-ins: >> %OUTPUTFILE%

for /R %vst3path% %%n in (*.vst3) do (
	echo( >> %OUTPUTFILE%
	echo %%n >> %OUTPUTFILE%
	"%vst3scannerexe%" -p "%%n" >> %OUTPUTFILE%
	if !ERRORLEVEL! neq 0 echo Failed with error !ERRORLEVEL! >> %OUTPUTFILE%
)

echo(
echo Done, wrote output to %OUTPUTFILE%
